#include <bits/stdc++.h>
using namespace std;

struct pretest_record {
    int shift, new_pattern;
};

vector<pretest_record> pretests;

struct pq_record {
    double winprob;
    int yvonne, zr, zindex;
};

bool operator< (const pq_record &A, const pq_record &B) {
    if (A.winprob != B.winprob) return A.winprob < B.winprob;
    return A.yvonne < B.yvonne;
}

vector<double> memo;

vector<int> precomputed_patterns[18][18];

void precompute_patterns() {
    for (int k=3; k<18; ++k) {
        for (int red=0; red<=k; ++red) {
            vector<int> pattern(k,0);
            for (int i=0; i<red; ++i) pattern[k-1-i] = 1;
            do {
                int current = 0;
                for (int x : pattern) current = (current << 1) | x;
                precomputed_patterns[k][red].push_back(current);
            } while (next_permutation(pattern.begin(),pattern.end()));
        }
    }
}

double winning_probability(int k, int yvonne, int zara, int prefix_who, int prefix_len, int red, int black) {
    if (prefix_len == k &&  prefix_who) return 1.0;
    if (prefix_len == k && !prefix_who) return 0.0;
    if (prefix_len + red + black < k) return 0.5;

    int key = (((((prefix_len << 1) | prefix_who) << 5) | red) << 5) | black;
    if (memo[key] >= 0) return memo[key];
    memo[key] = 0;
   
    for (int next_card = 0; next_card < 2; ++next_card) { // black, red
        if ((next_card && red==0) || (!next_card && black==0)) continue;
        int prefix = ( prefix_who ? (yvonne >> (k-prefix_len)) : (zara >> (k-prefix_len)) );
        prefix = ((prefix << 1) | next_card) & ((1 << k)-1);
        int new_len = prefix_len+1;
        int new_who = -1;
        while (true) {
            if ((yvonne >> (k-new_len)) == prefix) { new_who=1; break; }
            if ((zara >> (k-new_len)) == prefix) { new_who=0; break; }
            --new_len;
            prefix &= ~(1<<new_len);
        }
        memo[key] += (next_card ? red : black) * winning_probability( k, yvonne, zara, new_who, new_len, red-next_card, black-!next_card ) / (red+black);
    }
    return memo[key];
}

double winning_probability(int k, int yvonne, int zara) {
    // check for invalid cases first, handle them as Yvonne's wins
    if (yvonne == zara) return 1.;
    int selected_red = __builtin_popcount(yvonne) + __builtin_popcount(zara);
    int selected_black = 2*k - selected_red;
    if (selected_red > 26 || selected_black > 26) return 1.;
    // if we have a valid case, initialize the memoization table and run the DP
    int maxval = (((((k << 1) | 1) << 5) | 26) << 5) | 26;
    memo.clear();
    memo.resize(maxval,-1);
    return winning_probability(k,yvonne,zara,0,0,26-selected_red,26-selected_black);
}

void do_single_k(int k) {
    pretests = { {1,0}, {1,1}, {2,0}, {2,1}, {2,2}, {2,3}, {k,0}, {k,(1<<(k/2))-1}, {k,(1<<k)-1} };
    for (int i=3; i<k; ++i) {
        pretests.push_back( {i,0} );
        pretests.push_back( {i,(1<<(i/2))-1} );
        pretests.push_back( {i,(1<<i)-1} );
    }

    priority_queue<pq_record> candidates;

    for (int yr=0; 2*yr<=k; ++yr) for (int yvonne : precomputed_patterns[k][yr]) candidates.push( {0.5,yvonne,-1,0} );

    while (true) {
        pq_record processing = candidates.top();
        candidates.pop();

        double winprob = processing.winprob;
        int yvonne = processing.yvonne;
        int yr = __builtin_popcount(yvonne);
        int yb = k - yr;
        int zr = processing.zr;
        int zindex = processing.zindex;

        while (true) {
            if (zr == k+1) { cout << winprob << endl; return; }
            int zara = 0;
            if (zr == -1) {
                // special casing interesting patterns first
                int shift = pretests[zindex].shift;
                int new_pattern = pretests[zindex].new_pattern;
                zara = (yvonne >> shift) | (new_pattern << (k-shift));
                ++zindex;
                if (zindex == int(pretests.size())) { zr = 0; zindex = 0; }
            } else {
                int zb = k - zr;
                if (yr + zr + zr > 26) { zr = k+1; zindex = 0; continue; }
                if (yb + zb + zb > 26) { ++zr; zindex = 0; continue; }
                zara = precomputed_patterns[k][zr][zindex];
                ++zindex;
                if (zindex == int( precomputed_patterns[k][zr].size() )) { ++zr; zindex = 0; continue; }
            }

            double pp = winning_probability( k, yvonne, zara );
            if (pp < winprob - 1e-9) { candidates.push( { pp, yvonne, zr, zindex } ); break; }
        }
    }
}

int main() {
    cout << fixed << setprecision(20);
    precompute_patterns();
    for (int k=1; k<=26; ++k) {
        if (k < 3 || k >= 18) {
            cout << 0.5 << endl;
        } else {
            do_single_k(k);
        }
    }
}
